	.area text(rom,rel)
	.dbfile ..\..\..\..\..\DOCUME~1\Steve\MYDOCU~1\icctest\ASIO\asio.c
	.dbfile C:\DOCUME~1\Steve\MYDOCU~1\icctest\ASIO\asio.c
	.dbfunc e asio_init _asio_init fV
;          speed -> HRSP+0
;      txflowmap -> R4
;      rxflowmap -> R5
;          txmap -> R7
;          rxmap -> R6
_asio_init::
	@FENTER	
	.long R4,R5,R6,R7,R14,R15,0	
	mov R6,R0	
	mov R7,R1	
	mov R5,R2	
	mov R4,R3	
	.dbline -1
	.dbline 56
; /**
;  * @file asio.c - defines implementation for an
;  * asynchronous serial IO driver for Propeller C bringup.
;  * See header file for more details.
;  */
; #include "asio.h"
; #include <propeller.h>
; 
; /*
;  * These variables define the receive and transmit queues.
;  * The queue pointers will roll over when reaching ASIO_QUEUE_SIZE.
;  * ASIO_QUEUE_SIZE will be 2^N - 1 so we can use AND instead of MOD.
;  */
; int  asio_rxhead;
; int  asio_rxtail;
; char asio_rxq[ASIO_QUEUE_SIZE+1];
; 
; int  asio_txhead;
; int  asio_txtail;
; char asio_txq[ASIO_QUEUE_SIZE+1];
; 
; /*
;  * These variables define the interface connection.
;  */
; int  asio_rx_pinmap;
; int  asio_rxflow_pinmap;
; int  asio_tx_pinmap;
; int  asio_txflow_pinmap;
; 
; /*
;  * This variable defines the stack used with asio_handler.
;  */
; long asio_stack[10];
; 
; /*
;  * This variable defines the tick count required for a bit change.
;  */
; int  asio_tick;
; 
; /**
;  * Init interface direction bits and speed.
;  * Interface uses "N,1,8": no parity, 1 stop bit, 8 data bits.
;  * @note A pin map is a power of 2 integer representing the pin used for a function.
;  * If pin 0 is to be the receive pin, then 0x1 (2^0) would be passed via rxmap.
;  * @note Flow control parameters are reserved and have no affect today except
;  * the direction is set if the pinmap is non-zero for rxflow (backpressure bit).
;  * @note The only way to do invert on an interface today is to define override
;  * the default constant value. Using a variable would likely change timing.
;  * @param rxmap is receive pin map. 
;  * @param txmap is transmit pin map. 
;  * @param rxflowmap is receive flow control pin map; disabled if 0. 
;  * @param txflowmap is transmit flow control pin map; disabled if 0.
;  * @param speed is a typedef enum integer indicating interface bit rate. 
;  */
; void    asio_init (int rxmap, int txmap, int rxflowmap, int txflowmap, ASIO_SPEED_EN speed)
; {
	.dbline 57
;     asio_tx_pinmap        = txmap;
	@FLOAD	
	.long _asio_tx_pinmap	
	wrlong R7,TEMP0	
	.dbline 58
;     asio_rx_pinmap        = rxmap;
	@FLOAD	
	.long _asio_rx_pinmap	
	wrlong R6,TEMP0	
	.dbline 59
;     asio_rxflow_pinmap    = rxflowmap;
	@FLOAD	
	.long _asio_rxflow_pinmap	
	wrlong R5,TEMP0	
	.dbline 60
;     asio_txflow_pinmap    = txflowmap;
	@FLOAD	
	.long _asio_txflow_pinmap	
	wrlong R4,TEMP0	
	.dbline 64
; 
;     // Init DIRA pinmap in COG. Doing it here won't work.
;     
;     asio_txhead = 0;
	mov R15,#0	
	@FLOAD	
	.long _asio_txhead	
	wrlong R15,TEMP0	
	.dbline 65
;     asio_txtail = 0;
	mov R15,#0	
	@FLOAD	
	.long _asio_txtail	
	wrlong R15,TEMP0	
	.dbline 66
;     asio_rxhead = 0;
	mov R15,#0	
	@FLOAD	
	.long _asio_rxhead	
	wrlong R15,TEMP0	
	.dbline 67
;     asio_rxtail = 0;
	mov R15,#0	
	@FLOAD	
	.long _asio_rxtail	
	wrlong R15,TEMP0	
	.dbline 69
;     
;     asio_tick = (int)speed;
	mov TEMP0,HRSP	
	add TEMP0,#0	
	rdlong TEMP3,TEMP0	
	mov R15,TEMP3	
	and R15,#255	
	@FLOAD	
	.long _asio_tick	
	wrlong R15,TEMP0	
	.dbline 71
;     
;    	cognew(asio_handler, asio_stack);
	@FLOAD	
	.long _asio_handler	
	mov R0,TEMP0	
	@FLOAD	
	.long _asio_stack	
	mov R1,TEMP0	
	@FCALL	
	.long _cognew	
	.dbline -2
L2:
	@FPOP	
	.long R15,R14,R7,R6,R5,R4,0	
	@FRET	
	.dbline 0 ; func end
	.dbsym l speed 0 c
	.dbsym r txflowmap 4 I
	.dbsym r rxflowmap 5 I
	.dbsym r txmap 7 I
	.dbsym r rxmap 6 I
	.dbend
	.dbfunc e show_val _show_val fI
;             ii -> R4
;        syncmap -> R3
;         pinmap -> R2
;           mask -> R1
;            val -> R5
_show_val::
	@FENTER	
	.long R4,R5,0	
	mov R5,R0	
	.dbline -1
	.dbline 83
; }
; 
; /**
;  * Show bits on oscilloscope. This is for debug only ... bits come out LSB first
;  * @param val is value to show
;  * @param mask is the byte/word/long mask
;  * @param pinmap is the pin bit map for bit stream output
;  * @param syncmap is the bit map for bit stream oscope sync
;  * @returns non-zero for looping;
;  */
; static int show_val (int val, int mask, int pinmap, int syncmap)
; {
	.dbline 84
;     int ii = 1;
	mov R4,#1	
	.dbline 86
;     // set direction then set word syncmap bit
;     asm("or DIRA,%pinmap");
	or DIRA,R2
	.dbline 87
;     asm("or DIRA,%syncmap");
	or DIRA,R3
	.dbline 88
;     asm("or OUTA,%syncmap"); 
	or OUTA,R3
	add PC,#32	
L4:
	.dbline 90
;     //val = ~val;
;     while(ii & mask) { // this works
	.dbline 91
;         if(val & ii) {
	test R5,R4	WZ
IF_E	add PC,#8	
	.dbline 91
	.dbline 92
;             asm("or   OUTA,%pinmap");
	or   OUTA,R2
	.dbline 93
;         }
	add PC,#12	
L7:
	.dbline 94
;         else {
	.dbline 95
;             asm("andn OUTA,%pinmap");
	andn OUTA,R2
	.dbline 96
;             asm("andn OUTA,%pinmap"); // waveform symetry
	andn OUTA,R2
	.dbline 97
;             asm("andn OUTA,%pinmap"); // waveform symetry
	andn OUTA,R2
	.dbline 98
;         }
L8:
	.dbline 99
;         ii = ii << 1;
	shl R4,#1	
	.dbline 100
;     }
L5:
	.dbline 90
	test R4,R1	WZ
IF_NE	sub PC,#40	
	.dbline 101
;     asm("andn OUTA,%syncmap");
	andn OUTA,R3
	.dbline 102
;     return 1;
	mov R0,#1	
	.dbline -2
L3:
	@FPOP	
	.long R5,R4,0	
	@FRET	
	.dbline 0 ; func end
	.dbsym r ii 4 I
	.dbsym r syncmap 3 I
	.dbsym r pinmap 2 I
	.dbsym r mask 1 I
	.dbsym r val 5 I
	.dbend
	.dbfunc e asio_tx _asio_tx fV
;            val -> R0
_asio_tx::
	@FENTER	
	.long R14,R15,0	
	.dbline -1
	.dbline 110
; }
; 
; /**
;  * Transmit a char on interface.
;  * @param val is byte to send
;  */
; void    asio_tx (char val)
; {
L10:
	.dbline 112
;     while(asio_txtail != asio_txhead)
;         ; // wait for empty queue
L11:
	.dbline 111
	@FLOAD	
	.long _asio_txhead	
	rdlong R15,TEMP0	
	@FLOAD	
	.long _asio_txtail	
	rdlong R14,TEMP0	
	cmp R14,R15	WZ
IF_NE	sub PC,#32	
	.dbline 113
;     asio_txq[asio_txtail] = val;
	@FLOAD	
	.long _asio_txq	
	mov R15,TEMP0	
	@FLOAD	
	.long _asio_txtail	
	rdlong R14,TEMP0	
	add R14,R15	
	wrbyte R0,R14	
	.dbline 114
;     asio_txhead++;
	@FLOAD	
	.long _asio_txhead	
	rdlong R15,TEMP0	
	add R15,#1	
	@FLOAD	
	.long _asio_txhead	
	wrlong R15,TEMP0	
	.dbline 115
;     asio_txhead &= ASIO_QUEUE_SIZE;
	@FLOAD	
	.long _asio_txhead	
	rdlong R15,TEMP0	
	and R15,#255	
	@FLOAD	
	.long _asio_txhead	
	wrlong R15,TEMP0	
	.dbline -2
L9:
	@FPOP	
	.long R15,R14,0	
	@FRET	
	.dbline 0 ; func end
	.dbsym r val 0 c
	.dbend
	.dbfunc e asio_txString _asio_txString fV
;            str -> R4
_asio_txString::
	@FENTER	
	.long R4,R15,0	
	mov R4,R0	
	.dbline -1
	.dbline 123
; }
; 
; /**
;  * Transmit a string on interface.
;  * @param str is string to send.
;  */
; void    asio_txString (char* str)
; {
	add PC,#24	
L14:
	.dbline 124
;     while(*str != 0) {
	.dbline 125
;         asio_tx(*str);
	rdbyte R15,R4	
	mov R0,R15	
	and R0,#255	
	@FCALL	
	.long _asio_tx	
	.dbline 126
;         str++;
	add R4,#1	
	.dbline 127
;     }
L15:
	.dbline 124
	rdbyte R15,R4	
	and R15,#255	WZ
IF_NE	sub PC,#36	
	.dbline -2
L13:
	@FPOP	
	.long R15,R4,0	
	@FRET	
	.dbline 0 ; func end
	.dbsym r str 4 pc
	.dbend
	.dbfunc e asio_rx _asio_rx fI
;             rc -> R1
_asio_rx::
	@FENTER	
	.long R14,R15,0	
	.dbline -1
	.dbline 136
; }
; 
; /**
;  * Get a byte from the serial interface.
;  * param are set by # define constants in asio.h
;  * @returns int representing byte received.
;  */
; int asio_rx (void)
; {
L18:
	.dbline 138
;     int rc;
;     while(asio_rxhead == asio_rxtail) ; // wait for receive char
L19:
	.dbline 138
	@FLOAD	
	.long _asio_rxtail	
	rdlong R15,TEMP0	
	@FLOAD	
	.long _asio_rxhead	
	rdlong R14,TEMP0	
	cmp R14,R15	WZ
IF_E	sub PC,#32	
	.dbline 140
;     //while(!asio_rxready()) ;  // wait for receive char
;     rc = asio_rxq[asio_rxtail];
	@FLOAD	
	.long _asio_rxq	
	mov R15,TEMP0	
	@FLOAD	
	.long _asio_rxtail	
	rdlong R14,TEMP0	
	add R14,R15	
	rdbyte R15,R14	
	mov R1,R15	
	and R1,#255	
	.dbline 141
;     asio_rxtail++;
	@FLOAD	
	.long _asio_rxtail	
	rdlong R15,TEMP0	
	add R15,#1	
	@FLOAD	
	.long _asio_rxtail	
	wrlong R15,TEMP0	
	.dbline 142
;     asio_rxtail &= ASIO_QUEUE_SIZE;
	@FLOAD	
	.long _asio_rxtail	
	rdlong R15,TEMP0	
	and R15,#255	
	@FLOAD	
	.long _asio_rxtail	
	wrlong R15,TEMP0	
	.dbline 143
;     return rc;
	mov R0,R1	
	.dbline -2
L17:
	@FPOP	
	.long R15,R14,0	
	@FRET	
	.dbline 0 ; func end
	.dbsym r rc 1 I
	.dbend
	.dbfunc e asio_rxString _asio_rxString fI
;           byte -> R7
;             ii -> R4
;            len -> R6
;            str -> R5
_asio_rxString::
	@FENTER	
	.long R4,R5,R6,R7,R14,R15,0	
	mov R5,R0	
	mov R6,R1	
	.dbline -1
	.dbline 165
; }
; 
; /*
;  * asio_rxready ----> doesn't work ... why not ??? it should <-----
;  * Get queue status and return non-zero if byte is available.
;  * returns non-zero if rx ready with byte.
; int     asio_rxready (void);
; int asio_rxready (void)
; {
;     return (asio_rxhead != asio_rxtail);
; }
; */
; 
; /**
;  * Use calls to asio_rx until a terminator like "\r" is found.
;  * All strings returned are null terminated.
;  * @param str is a predefined input buffer of len.
;  * @param len is maximum number of chars to receive in buffer.
;  * @returns number of bytes received.
;  */
; int asio_rxString (char* str, int len)
; {
	.dbline 166
;     int byte = 0;
	mov R7,#0	
	.dbline 167
;     int ii = 0;
	mov R4,#0	
L22:
	.dbline 168
;     do {
	.dbline 169
;         byte = asio_rx();
	@FCALL	
	.long _asio_rx	
	mov R7,R0	
	.dbline 170
;         str[ii] = byte;
	mov R15,R4	
	add R15,R5	
	mov R14,R7	
	wrbyte R14,R15	
	.dbline 171
;         if(byte == ASIO_ENTER) {
	cmp R7,#13	WZ
IF_NE	add PC,#4	
	.dbline 171
	.dbline 172
;            break;
	add PC,#12	
L25:
	.dbline 174
;         }
;         ii++;
	add R4,#1	
	.dbline 175
;     } while(ii < len);
L23:
	.dbline 175
	cmps R4,R6	WC
IF_B	sub PC,#52	
L24:
	.dbline 177
;     
;     if(ii < (len-1)) ii++;
	mov R15,R6	
	sub R15,#1	
	cmps R4,R15	WC
IF_AE	add PC,#4	
	.dbline 177
	add R4,#1	
L27:
	.dbline 178
;     str[ii] = '\0';
	mov R15,R4	
	add R15,R5	
	mov R14,#0	
	wrbyte R14,R15	
	.dbline 180
;     
;     return ii;
	mov R0,R4	
	.dbline -2
L21:
	@FPOP	
	.long R15,R14,R7,R6,R5,R4,0	
	@FRET	
	.dbline 0 ; func end
	.dbsym r byte 7 I
	.dbsym r ii 4 I
	.dbsym r len 6 I
	.dbsym r str 5 pc
	.dbend
	.dbfunc e asio_handler _asio_handler fV
;         rxbyte -> R7
;          rxcnt -> R3
;          txcnt -> R5
;        ticksav -> R4
;         rxsync -> R9
;           tick -> R8
;          count -> R1
;           time -> R0
;            tmp -> R6
;         txbyte -> R2
;             ii -> R7
_asio_handler::
	@FENTER	
	.long R4,R5,R6,R7,R8,R9,R14,R15,0	
	.dbline -1
	.dbline 200
; }
; 
; 
; //#define ASIO_DEBUG 1
; /**
;  * Handle transmit and receive here.
;  * Hard to make our deadline ... again :)
;  * LMM/Time lessons learned with beta preview:
;  * - Don't ever use a C global with asm("...").
;  * - Using globals for decisions takes lots of time. Use locals instead.
;  * - Using function calls are expensive (figures) costs 2us for 80MHz prop.
;  * - Using "if" in C code is also expensive costs 2us for 80MHz prop.
;  * Interestingly, if(--var) ... is cheaper than if(var) ....
;  * - Use asm(test ... wz), asm(IF_Z ....) costs 1us for 80MHz prop.
;  * - A while(1) costs 0.5us to 0.7us for 80MHz prop.
;  * - A for(;;) costs 0.5us to 0.7us for 80MHz prop.
;  * - Using too many local variables in a function can throw compiler errors.
;  */
; void asio_handler(void)
; {
	.dbline 202
;     int ii, tmp;
;     int time    = 0;
	mov R0,#0	
	.dbline 203
;     int count   = ASIO_TICK_COUNT;
	@FLOAD	
	.long 630	
	mov R1,TEMP0	
	.dbline 205
;    
;     int txcnt   = 0;
	mov R5,#0	
	.dbline 206
;     int txbyte  = 0;
	mov R2,#0	
	.dbline 208
;         
;     int rxsync  = 0;
	mov R9,#0	
	.dbline 209
;     int rxcnt   = 0;
	mov R3,#0	
	.dbline 210
;     int rxbyte  = 0;
	mov R7,#0	
	.dbline 212
; 
;     int tick    = asio_tick;
	@FLOAD	
	.long _asio_tick	
	rdlong R8,TEMP0	
	.dbline 213
;     int ticksav = tick; // much faster than global
	mov R4,R8	
	.dbline 218
;     
;     // I/O pins must be set on a code-per-cog basis.
;     // Setting pins from another cog's code won't work.
;     
;     tmp = asio_tx_pinmap;
	@FLOAD	
	.long _asio_tx_pinmap	
	rdlong R6,TEMP0	
	.dbline 219
;     asm("or     dira, %tmp");       // set outputs
	or     dira, R6
	.dbline 220
;     tmp = asio_rx_pinmap;
	@FLOAD	
	.long _asio_rx_pinmap	
	rdlong R6,TEMP0	
	.dbline 221
;     asm("andn   dira, %tmp");       // set inputs
	andn   dira, R6
	.dbline 222
;     tmp = asio_rxflow_pinmap;
	@FLOAD	
	.long _asio_rxflow_pinmap	
	rdlong R6,TEMP0	
	.dbline 223
;     asm("or     dira, %tmp");       // rx flow is an output (RTS)
	or     dira, R6
	.dbline 224
;     tmp = asio_txflow_pinmap;
	@FLOAD	
	.long _asio_txflow_pinmap	
	rdlong R6,TEMP0	
	.dbline 225
;     asm("andn   dira, %tmp");       // tx flow is an input  (CTS)
	andn   dira, R6
	.dbline 227
; 
;     tmp = ~ASIO_TX_INVERTED;        // set tx line to idle level
	@FLOAD	
	.long -1	
	mov R6,TEMP0	
	.dbline 228
;     asm("test       %tmp, #1 wz");  // so first output char is right
	test       R6, #1 wz
	.dbline 229
;     tmp = asio_tx_pinmap;
	@FLOAD	
	.long _asio_tx_pinmap	
	rdlong R6,TEMP0	
	.dbline 230
;     asm("IF_Z       andn    OUTA,   %tmp"); // 0? bit = 0;
	IF_Z       andn    OUTA,   R6
	.dbline 231
;     asm("IF_NZ      or      OUTA,   %tmp"); // 1? bit = 1;
	IF_NZ      or      OUTA,   R6
	.dbline 263
; 
;     /*
;      * Basic handler algorithm:
;      * Setting/Saving a new rx/tx byte is not time critical;
;      * Getting a bit on rx or setting a bit on tx is time critical.
;      * Waitcnt in very slow code can cause failure. Current
;      * minimum code time is 625 ticks, current tick count 630.
;      *
;      * Get rx state.
;      * If rx state == mark (ASIO_RX_INVERTED) & rx not in progress,
;      *    start new byte rx set new wait and continue
;      *
;      * Else
;      *   set tick to bit tick time
;      *   If rx byte in progress,
;      *      if tick > 0, decrement tick wait and continue
;      *      else
;      *        set tick to bit tick time
;      *        save bit to rxbyte wait and continue
;      *   If tx byte in progress,
;      *      if tick > 0, decrement tick wait and continue
;      *      else
;      *        set next bit from txbyte wait and continue
;      *   Else if tx tail != head,
;      *      load txbyte and tx start bit
;      */
; 
; #if ASIO_DEBUG
;     asm("or      dira, #$c1");
; #endif
; 
;     for(;;) // forever
L30:
	.dbline 264
;     {
	.dbline 265
;         asm("mov        %time, cnt");
	mov        R0, cnt
	.dbline 266
;         asm("add        %time, %count");
	add        R0, R1
	.dbline 268
; 
;         rxsync = asio_rx_pinmap;
	@FLOAD	
	.long _asio_rx_pinmap	
	rdlong R9,TEMP0	
	.dbline 269
;         asm("and        %rxsync, INA wz");
	and        R9, INA wz
	.dbline 270
;         asm("muxnz      %rxsync, #1");
	muxnz      R9, #1
	.dbline 272
; 
;         rxsync |= rxcnt << 8;        
	mov R15,R3	
	shl R15,#8	
	or R9,R15	WZ
	.dbline 274
;         // if rxcnt != 0, then tmp != ASIO_RX_INVERTED
;         if(rxsync == ASIO_RX_INVERTED) 
IF_NE	add PC,#56	
	.dbline 275
;         {
	.dbline 279
; #if ASIO_DEBUG
;             asm("or     outa, #$80");
; #endif
;             rxcnt  = 8;     // start another byte only if rxcnt == 0
	mov R3,#8	
	.dbline 280
;             rxbyte = 0;     // clear byte rx accumulator
	mov R7,#0	
	.dbline 283
;             
;             // get a good bit sample point
;             tmp  = count >> 0;
	mov R6,R1	
	.dbline 285
;             //tmp += count >> 1;     // -600 to +0;
;             asm("mov        %time, cnt");
	mov        R0, cnt
	.dbline 286
;             asm("add        %time, %tmp");
	add        R0, R6
	.dbline 287
;             tick   = ticksav >> 1; // set tick for bit positioning
	mov R8,R4	
	sar R8,#1	
	add PC,#4	
L36:
	.dbline 289
;             // would use for loop, but ICC is out of variables for asm here
;             while(tick--) {
	.dbline 290
;                 asm("waitcnt    %time, %count");
	waitcnt    R0, R1
	.dbline 291
;             }
L37:
	.dbline 289
	mov R15,R8	WZ
	sub R8,#1	
IF_NE	sub PC,#16	
	.dbline 292
;             tick   = ticksav; // reset tick for new char timing
	mov R8,R4	
	.dbline 298
;             
; #if ASIO_DEBUG
;             asm("andn   outa, #1");
; #endif
;       
;             continue;
	sub PC,#100	
L34:
	.dbline 302
;         }
; 
;         //   if rx byte in progress, get bit in rxbyte
;         if(rxcnt > 0)
	cmps R3,#0	WZ WC
IF_BE	add PC,#216	
	.dbline 303
;         {
	.dbline 305
;             // if not tick time, decrement tick and continue
;             if(--tick > 0) {
	mov R15,R8	
	sub R15,#1	WZ WC
	mov R8,R15	
IF_BE	add PC,#8	
	.dbline 305
	.dbline 306
;                 asm("waitcnt    %time, %count");
	waitcnt    R0, R1
	.dbline 307
;                 continue;
	sub PC,#132	
L41:
	.dbline 310
;             }
;             // reset tick to bit tick time after tick == 0
;             tick = ticksav;
	mov R8,R4	
	.dbline 316
;             
; #if ASIO_DEBUG
;             asm("xor    outa, #1"); // debug only
; #endif
; 
;             rxsync = ASIO_RX_INVERTED ? ~rxsync : rxsync;
	.dbline 317
;             asm("and    %rxsync, #1");
	and    R9, #1
	.dbline 318
;             rxbyte |= rxsync << (8-rxcnt);
	mov R15,#8	
	sub R15,R3	
	mov R14,R9	
	shl R14,R15	
	or R7,R14	
	.dbline 319
;             if(--rxcnt == 0) {    // if rxcnt 0, full byte received. save in buffer.
	mov R15,R3	
	sub R15,#1	WZ
	mov R3,R15	
IF_NE	add PC,#136	
	.dbline 319
	.dbline 320
;                 if(ASIO_RX_INVERTED) rxbyte ^= 0xff;
	add PC,#0	
L45:
	.dbline 321
;                 asio_rxq[asio_rxhead] = rxbyte;
	@FLOAD	
	.long _asio_rxq	
	mov R15,TEMP0	
	@FLOAD	
	.long _asio_rxhead	
	rdlong R14,TEMP0	
	add R14,R15	
	mov R15,R7	
	wrbyte R15,R14	
	.dbline 322
;                 asio_rxhead++;
	@FLOAD	
	.long _asio_rxhead	
	rdlong R15,TEMP0	
	add R15,#1	
	@FLOAD	
	.long _asio_rxhead	
	wrlong R15,TEMP0	
	.dbline 323
;                 asio_rxhead &= ASIO_QUEUE_SIZE;
	@FLOAD	
	.long _asio_rxhead	
	rdlong R15,TEMP0	
	and R15,#255	
	@FLOAD	
	.long _asio_rxhead	
	wrlong R15,TEMP0	
	.dbline 329
; #if ASIO_DEBUG
;                 asm("andn outa, #$80");
;                 asm("andn outa, #1"); // debug only
; #endif
; 
;                 asm("mov        %time, cnt");
	mov        R0, cnt
	.dbline 330
;                 asm("add        %time, %count");    // wait stop-bit time
	add        R0, R1
	.dbline 331
;                 for(ii = 0; ii < ticksav; ii++) {
	mov R7,#0	
	add PC,#8	
L47:
	.dbline 331
	.dbline 332
;                     asm("waitcnt    %time, %count");
	waitcnt    R0, R1
	.dbline 333
;                 }
L48:
	.dbline 331
	add R7,#1	
L50:
	.dbline 331
	cmps R7,R4	WC
IF_B	sub PC,#16	
	.dbline 334
;                 continue;
	rdlong PC,PC	
	.long L30	
L43:
	.dbline 336
;             }
;             asm("waitcnt    %time, %count");
	waitcnt    R0, R1
	.dbline 337
;             continue;
	rdlong PC,PC	
	.long L30	
L39:
	.dbline 341
;         }
;         
;         //   if tx byte count in progress, set next bit from txbyte
;         if(txcnt > 0)
	cmps R5,#0	WZ WC
IF_BE	add PC,#72	
	.dbline 342
;         {
	.dbline 344
;             // if not tick time, decrement tick and continue
;             if(--tick > 0) {
	mov R15,R8	
	sub R15,#1	WZ WC
	mov R8,R15	
IF_BE	add PC,#12	
	.dbline 344
	.dbline 345
;                 asm("waitcnt    %time, %count");
	waitcnt    R0, R1
	.dbline 346
;                 continue;
	rdlong PC,PC	
	.long L30	
L53:
	.dbline 349
;             }
;             // reset tick to bit tick time after tick == 0
;             tick = ticksav;
	mov R8,R4	
	.dbline 351
;             
;             txcnt--;    // only decr txcnt after timer expires
	sub R5,#1	
	.dbline 352
;             tmp = asio_tx_pinmap;
	@FLOAD	
	.long _asio_tx_pinmap	
	rdlong R6,TEMP0	
	.dbline 353
;             asm("test       %txbyte, #1 wz");
	test       R2, #1 wz
	.dbline 354
;             asm("muxnz      OUTA, %tmp");
	muxnz      OUTA, R6
	.dbline 355
;             asm("shr        %txbyte, #1");          // txbyte >>= 1;
	shr        R2, #1
	.dbline 356
;             asm("waitcnt    %time, %count");
	waitcnt    R0, R1
	.dbline 357
;             continue;
	rdlong PC,PC	
	.long L30	
L51:
	.dbline 361
;         }
; 
;         //   else if tx tail != head, load txbyte and tx start bit
;         txcnt = 0;
	mov R5,#0	
	.dbline 362
;         if(asio_txtail == asio_txhead) {
	@FLOAD	
	.long _asio_txhead	
	rdlong R15,TEMP0	
	@FLOAD	
	.long _asio_txtail	
	rdlong R14,TEMP0	
	cmp R14,R15	WZ
IF_NE	add PC,#12	
	.dbline 362
	.dbline 363
;             asm("waitcnt    %time, %count");
	waitcnt    R0, R1
	.dbline 367
; #if ASIO_DEBUG
;             asm("andn outa, #$40");
; #endif
;             continue;
	rdlong PC,PC	
	.long L30	
L55:
	.dbline 370
;         }
; 
;         tmp = asio_txq[asio_txtail];    // get new byte
	@FLOAD	
	.long _asio_txq	
	mov R15,TEMP0	
	@FLOAD	
	.long _asio_txtail	
	rdlong R14,TEMP0	
	add R14,R15	
	rdbyte R15,R14	
	mov R6,R15	
	and R6,#255	
	.dbline 371
;         txbyte = 0;
	mov R2,#0	
	.dbline 372
;         for(ii = 0; ii < 8; ii++) {     // shuffle bits so they go out correctly
	mov R7,#0	
L57:
	.dbline 372
	.dbline 373
;             txbyte |= (tmp & (0x80 >> ii)) ? 0 : 1;
	mov R15,#128	
	sar R15,R7	
	test R6,R15	WZ
IF_E	add PC,#8	
	mov R8,#0	
	add PC,#4	
L62:
	mov R8,#1	
L63:
	or R2,R8	
	.dbline 374
;             txbyte <<= 1;
	shl R2,#1	
	.dbline 375
;         }
L58:
	.dbline 372
	add R7,#1	
	.dbline 372
	cmps R7,#8	WC
IF_B	sub PC,#48	
	.dbline 377
; 
;         txbyte |= 1; // start bit
	or R2,#1	
	.dbline 378
;         asio_txtail++;
	@FLOAD	
	.long _asio_txtail	
	rdlong R15,TEMP0	
	add R15,#1	
	@FLOAD	
	.long _asio_txtail	
	wrlong R15,TEMP0	
	.dbline 379
;         asio_txtail &= ASIO_QUEUE_SIZE;
	@FLOAD	
	.long _asio_txtail	
	rdlong R15,TEMP0	
	and R15,#255	
	@FLOAD	
	.long _asio_txtail	
	wrlong R15,TEMP0	
	.dbline 381
; 
;         if(!ASIO_TX_INVERTED) txbyte = ~txbyte;
	.dbline 381
	neg R2,R2	
	sub R2,#1	
L64:
	.dbline 382
;         txcnt = 9 + ASIO_STOP_BITS;
	mov R5,#11	
	.dbline 391
; 
; #if ASIO_DEBUG
;         asm("or outa, #$40");
; #endif
; 
;         // end of start tx
;         
;         // end ... tx
;     }
	.dbline 263
	.dbline 263
	rdlong PC,PC	
	.long L30	
X0:
	.dbline -2
L29:
	@FPOP	
	.long R15,R14,R9,R8,R7,R6,R5,R4,0	
	@FRET	
	.dbline 0 ; func end
	.dbsym r rxbyte 7 I
	.dbsym r rxcnt 3 I
	.dbsym r txcnt 5 I
	.dbsym r ticksav 4 I
	.dbsym r rxsync 9 I
	.dbsym r tick 8 I
	.dbsym r count 1 I
	.dbsym r time 0 I
	.dbsym r tmp 6 I
	.dbsym r txbyte 2 I
	.dbsym r ii 7 I
	.dbend
	.area bss(ram,rel)
	.dbfile C:\DOCUME~1\Steve\MYDOCU~1\icctest\ASIO\asio.c
L67:
	.blkb 256
	.area text(rom,rel)
	.dbfile C:\DOCUME~1\Steve\MYDOCU~1\icctest\ASIO\asio.c
	.dbfunc e main _main fI
	.dbsym s rxbuf L67 A[256:256]c
;             ch -> R5
;             ii -> R4
;           argv -> <dead>
;           argc -> <dead>
_main::
	sub HRSP,#4	
	.dbline -1
	.dbline 397
; }
; 
; //#define ASIO_TEST
; #ifdef  ASIO_TEST
; int main (int argc, char** argv)
; {
	.dbline 398
;     int ii = 0;
	mov R4,#0	
	.dbline 401
;     static char rxbuf[ASIO_BUFF_LEN+1]; 
; 
;     asio_init(ASIO_PIN_MAP(31), ASIO_PIN_MAP(30), 0, 0, ASIO_57600);
	@FLOAD	
	.long -2147483648	
	mov R0,TEMP0	
	@FLOAD	
	.long 1073741824	
	mov R1,TEMP0	
	mov R2,#0	
	mov R3,#0	
	mov R15,#2	
	mov TEMP4,HRSP	
	wrlong R15,TEMP4	
	@FCALL	
	.long _asio_init	
	.dbline 403
;     
;     asio_rx(); // block until user opens connection
	@FCALL	
	.long _asio_rx	
	.dbline 404
;     asio_txString("Hello World!\r\n");
	@FLOAD	
	.long L68	
	mov R0,TEMP0	
	@FCALL	
	.long _asio_txString	
	add PC,#172	
L69:
	.dbline 406
;     
;     while(0) {
	.dbline 407
;         asio_tx('U');
	mov R0,#85	
	@FCALL	
	.long _asio_tx	
	.dbline 408
;     }
	.dbline 406
	add PC,#156	
L72:
	.dbline 409
;     while(0) {
	.dbline 410
;         asio_tx('H');
	mov R0,#72	
	@FCALL	
	.long _asio_tx	
	.dbline 411
;         asio_tx('i');
	mov R0,#105	
	@FCALL	
	.long _asio_tx	
	.dbline 412
;         asio_tx(' ');
	mov R0,#32	
	@FCALL	
	.long _asio_tx	
	.dbline 413
;     }
	.dbline 409
	add PC,#116	
L75:
	.dbline 414
;     while(0) {
	.dbline 415
;         asio_txString("Hello World!\r\n");
	@FLOAD	
	.long L68	
	mov R0,TEMP0	
	@FCALL	
	.long _asio_txString	
	.dbline 416
;     }
	.dbline 414
	add PC,#92	
L78:
	.dbline 417
;     while(0) {
	.dbline 418
;         ii = asio_rx();
	@FCALL	
	.long _asio_rx	
	mov R4,R0	
	.dbline 420
;         //show_val(ii, 0xff, 0x1, 0x2);
;     }
	.dbline 417
	add PC,#76	
L81:
	.dbline 421
;     while(0) {  // echo test
	.dbline 422
;         int ch = asio_rx();
	@FCALL	
	.long _asio_rx	
	mov R5,R0	
	.dbline 424
;         //for(ii = 0; ii < 500; ii++) ;
;         asio_tx(ch);
	and R0,#255	
	@FCALL	
	.long _asio_tx	
	.dbline 425
;     }
	.dbline 421
	add PC,#48	
L84:
	.dbline 426
;     while(1) {  // echo string test
	.dbline 427
;         ii = asio_rxString(rxbuf, ASIO_BUFF_LEN);
	@FLOAD	
	.long L67	
	mov R0,TEMP0	
	mov R1,#255	
	@FCALL	
	.long _asio_rxString	
	mov R4,R0	
	.dbline 430
;         //show_val(ii, 0xff, 0x1, 0x2);
;         //for(ii = 0; ii < 500; ii++) ; // pause before send
;         asio_txString(rxbuf);
	@FLOAD	
	.long L67	
	mov R0,TEMP0	
	@FCALL	
	.long _asio_txString	
	.dbline 431
;     }
L85:
	.dbline 426
	sub PC,#52	
X1:
	.dbline -2
L66:
	add HRSP,#4	
	@FRET	
	.dbline 0 ; func end
	.dbsym r ch 5 I
	.dbsym r ii 4 I
	.dbsym l argv 3 ppc
	.dbsym l argc 3 I
	.dbend
	.area bss(ram,rel)
	.dbfile C:\DOCUME~1\Steve\MYDOCU~1\icctest\ASIO\asio.c
	.align	4
_asio_tick::
	.blkb 4
	.dbsym e asio_tick _asio_tick I
	.align	4
_asio_stack::
	.blkb 40
	.dbsym e asio_stack _asio_stack A[40:10]L
	.align	4
_asio_txflow_pinmap::
	.blkb 4
	.dbsym e asio_txflow_pinmap _asio_txflow_pinmap I
	.align	4
_asio_tx_pinmap::
	.blkb 4
	.dbsym e asio_tx_pinmap _asio_tx_pinmap I
	.align	4
_asio_rxflow_pinmap::
	.blkb 4
	.dbsym e asio_rxflow_pinmap _asio_rxflow_pinmap I
	.align	4
_asio_rx_pinmap::
	.blkb 4
	.dbsym e asio_rx_pinmap _asio_rx_pinmap I
_asio_txq::
	.blkb 256
	.dbsym e asio_txq _asio_txq A[256:256]c
	.align	4
_asio_txtail::
	.blkb 4
	.dbsym e asio_txtail _asio_txtail I
	.align	4
_asio_txhead::
	.blkb 4
	.dbsym e asio_txhead _asio_txhead I
_asio_rxq::
	.blkb 256
	.dbsym e asio_rxq _asio_rxq A[256:256]c
	.align	4
_asio_rxtail::
	.blkb 4
	.dbsym e asio_rxtail _asio_rxtail I
	.align	4
_asio_rxhead::
	.blkb 4
	.dbsym e asio_rxhead _asio_rxhead I
	.area lit(rom,rel)
L68:
	.byte 'H,'e,'l,'l,'o,32,'W,'o,'r,'l,'d,33,13,10,0
